Blame localedata/tst-fmon.sh

Packit 6c4009
#!/bin/sh
Packit 6c4009
# Testing the implementation of strfmon(3).
Packit 6c4009
# Copyright (C) 1996-2018 Free Software Foundation, Inc.
Packit 6c4009
# This file is part of the GNU C Library.
Packit 6c4009
# Contributed by Jochen Hein <jochen.hein@delphi.central.de>, 1997.
Packit 6c4009
Packit 6c4009
# The GNU C Library is free software; you can redistribute it and/or
Packit 6c4009
# modify it under the terms of the GNU Lesser General Public
Packit 6c4009
# License as published by the Free Software Foundation; either
Packit 6c4009
# version 2.1 of the License, or (at your option) any later version.
Packit 6c4009
Packit 6c4009
# The GNU C Library is distributed in the hope that it will be useful,
Packit 6c4009
# but WITHOUT ANY WARRANTY; without even the implied warranty of
Packit 6c4009
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Packit 6c4009
# Lesser General Public License for more details.
Packit 6c4009
Packit 6c4009
# You should have received a copy of the GNU Lesser General Public
Packit 6c4009
# License along with the GNU C Library; if not, see
Packit 6c4009
# <http://www.gnu.org/licenses/>.
Packit 6c4009
Packit 6c4009
set -e
Packit 6c4009
Packit 6c4009
common_objpfx=$1
Packit 6c4009
run_program_prefix_before_env=$2
Packit 6c4009
run_program_env=$3
Packit 6c4009
run_program_prefix_after_env=$4
Packit 6c4009
test_program_prefix=$5
Packit 6c4009
datafile=$6
Packit 6c4009
Packit 6c4009
here=`pwd`
Packit 6c4009
Packit 6c4009
lang=`sed -e '/^#/d' -e '/^$/d' -e '/^C	/d' -e '/^tstfmon/d' -e 's/^\([^	]*\).*/\1/' $datafile | sort | uniq`
Packit 6c4009
Packit 6c4009
# Generate data files.
Packit 6c4009
for cns in `cd ./tst-fmon-locales && ls tstfmon_*`; do
Packit 6c4009
    ret=0
Packit 6c4009
    cn=tst-fmon-locales/$cns
Packit 6c4009
    fn=charmaps/ISO-8859-1
Packit 6c4009
    # All of the test locales run with "USC " as their int_curr_symbol,
Packit 6c4009
    # and the use of this generates a warning because it does not meet
Packit 6c4009
    # the POSIX requirement that the name be an ISO 4217 compliant
Packit 6c4009
    # country code e.g. USD.  Therefore we *expect* an exit code of 1.
Packit 6c4009
    ${run_program_prefix_before_env} \
Packit 6c4009
    ${run_program_env} \
Packit 6c4009
    I18NPATH=. \
Packit 6c4009
    ${run_program_prefix_after_env} ${common_objpfx}locale/localedef \
Packit 6c4009
    --quiet -i $cn -f $fn ${common_objpfx}localedata/$cns || ret=$?
Packit 6c4009
    if [ $ret -ne 1 ]; then
Packit 6c4009
	echo "FAIL: Locale compilation for $cn failed (error $ret)."
Packit 6c4009
	exit 1
Packit 6c4009
    fi
Packit 6c4009
done
Packit 6c4009
Packit 6c4009
# Run the tests.
Packit 6c4009
errcode=0
Packit 6c4009
# There's a TAB for IFS
Packit 6c4009
while IFS="	" read locale format value expect; do
Packit 6c4009
    case "$locale" in '#'*) continue ;; esac
Packit 6c4009
    if [ -n "$format" ]; then
Packit 6c4009
	ret=0
Packit 6c4009
	expect=`echo "$expect" | sed 's/^\"\(.*\)\"$/\1/'`
Packit 6c4009
	${test_program_prefix} ${common_objpfx}localedata/tst-fmon \
Packit 6c4009
	"$locale" "$format" "$value" "$expect" < /dev/null || ret=$?
Packit 6c4009
        if [ $ret -ne 0 ]; then
Packit 6c4009
	    echo "FAIL: Locale $locale failed the test (error $ret)."
Packit 6c4009
	    errcode=1
Packit 6c4009
	fi
Packit 6c4009
    fi
Packit 6c4009
done < $datafile
Packit 6c4009
Packit 6c4009
exit $errcode
Packit 6c4009
# Local Variables:
Packit 6c4009
#  mode:shell-script
Packit 6c4009
# End: